#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1200four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 1200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1200four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four12004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four12004xi = {
                1:'1004x-652y68z',
                2:'1038x-599y56z',
                3:'1051x-377y663z',
                4:'1068x-544y44z',
                5:'1095x-487y32z',
                6:'110x-59y1193z',
                7:'1120x-429y20z',
                8:'1141x-370y8z',
                9:'115x-241y1169z',
                10:'122x-1162y270z',
                11:'124x-58y1192z',
                12:'133x-245y1167z',
                13:'138x-56y1190z',
                14:'151x-248y1164z',
                15:'152x-53y1189z',
                16:'166x-48y1187z',
                17:'171x-249y1161z',
                18:'180x-42y1185z',
                19:'183x-1157y258z',
                20:'191x-249y1158z',
                21:'193x-35y1183z',
                22:'196x-477y1083z',
                23:'207x-26y1181z',
                24:'211x-247y1154z',
                25:'219x-16y1179z',
                26:'225x-476y1077z',
                27:'232x-244y1151z',
                28:'232x-5y1177z',
                29:'244x-1148y246z',
                30:'252x-240y1148z',
                31:'255x-473y1072z',
                32:'273x-234y1144z',
                33:'285x-468y1067z',
                34:'294x-226y1141z',
                35:'304x-1136y235z',
                36:'315x-217y1137z',
                37:'315x-461y1061z',
                38:'320x-677y936z',
                39:'336x-206y1133z',
                40:'345x-452y1056z',
                41:'356x-193y1129z',
                42:'359x-668y929z',
                43:'364x-1121y223z',
                44:'375x-442y1050z',
                45:'376x-179y1125z',
                46:'395x-164y1121z',
                47:'399x-656y921z',
                48:'405x-429y1044z',
                49:'414x-146y1116z',
                50:'423x-1102y211z',
                51:'431x-128y1112z',
                52:'435x-414y1038z',
                53:'438x-642y914z',
                54:'443x-824y750z',
                55:'448x-107y1107z',
                56:'464x-398y1032z',
                57:'464x-86y1102z',
                58:'476x-625y906z',
                59:'479x-63y1098z',
                60:'481x-1080y199z',
                61:'489x-806y741z',
                62:'492x-379y1026z',
                63:'493x-39y1093z',
                64:'505x-13y1088z',
                65:'514x-606y898z',
                66:'520x-359y1019z',
                67:'535x-786y731z',
                68:'538x-1056y187z',
                69:'546x-336y1013z',
                70:'551x-585y890z',
                71:'572x-312y1007z',
                72:'579x-762y722z',
                73:'588x-562y882z',
                74:'593x-1027y175z',
                75:'597x-286y1000z',
                76:'61x-1164y281z',
                77:'620x-258y993z',
                78:'623x-536y874z',
                79:'623x-736y712z',
                80:'642x-229y987z',
                81:'647x-996y164z',
                82:'657x-508y865z',
                83:'663x-198y980z',
                84:'666x-708y703z',
                85:'682x-165y973z',
                86:'690x-477y857z',
                87:'699x-131y966z',
                88:'699x-962y152z',
                89:'707x-677y693z',
                90:'714x-95y959z',
                91:'71x-54y1196z',
                92:'721x-445y848z',
                93:'728x-58y951z',
                94:'740x-21y944z',
                95:'747x-643y683z',
                96:'750x-926y140z',
                97:'751x-411y840z',
                98:'779x-375y831z',
                99:'785x-608y673z',
                100:'798x-886y128z',
                101:'805x-337y823z',
                102:'81x-230y1174z',
                103:'821x-569y663z',
                104:'829x-297y814z',
                105:'83x-57y1195z',
                106:'844x-844y116z',
                107:'851x-255y805z',
                108:'855x-529y653z',
                109:'871x-212y796z',
                110:'888x-487y643z',
                111:'888x-799y104z',
                112:'889x-168y787z',
                113:'904x-122y778z',
                114:'917x-75y769z',
                115:'918x-442y633z',
                116:'928x-27y760z',
                117:'929x-752y92z',
                118:'945x-396y623z',
                119:'968x-703y80z',
                120:'97x-236y1172z',
                121:'97x-59y1194z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1200four4xi" usage = "target function for charge12004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1200four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1200FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1200FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1200FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1200FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1200FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four12004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1200FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1200FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1200FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four12004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four12004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1200FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1200FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1200FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1200four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
              
                      